<template>
  <div class="app-container">
    <van-nav-bar
      left-arrow
      fixed
      placeholder
      @click-left="$router.back(-1)"
    >
      <template #title>
        <p style="font-weight: bold;">添加母子转账申请</p>
      </template>
    </van-nav-bar>
    <van-form @submit="getChange" @failed="getError" :show-error-message="false" scroll-to-error validate-first>
      <p class="main_title">基础信息</p>
      <div class="main_box">
        <van-field
          readonly
          clickable
          required
          :rules="[{ required: true , message:'请选择申请时间'  }]"
          v-model="form.applyDate"
          label="申请时间"
          placeholder="请选择申请时间"
          @click="showlasj = true"
          input-align="right"
          right-icon="arrow-down"
        />
        <van-popup v-model="showlasj" position="bottom">
          <van-datetime-picker
            v-model="currentDate"
            type="date"
            title="选择年月日"
            :min-date="minDate"
            :max-date="maxDate"
            @confirm="onConfirmLasj"
            @cancel="showlasj = false"
          />
        </van-popup>
        <van-field
          readonly
          clickable
          required
          :rules="[{ required: true , message:'请选择资金支出类别' }]"
          label="资金支出类别"
          placeholder="请选择"
          v-model="capitalExpenditureType"
          @click="showcapital = true"
          input-align="right"
          right-icon="arrow-down"
          label-width="auto"
        />
        <van-popup v-model="showcapital" position="bottom">
          <van-picker
            show-toolbar
            :columns="capitalExpenditureTypeOptions"
            @confirm="onConfirmCapital"
            @cancel="showcapital = false"
          />
        </van-popup>
        <van-field
          readonly
          required
          label="支出总金额"
          v-model="form.expenditureAmount"
          placeholder="根据下方收款金额自动核算"
          input-align="right"
          label-width="auto"
        />

      </div>

      <div class="main_box" style="margin-top: 10px;">
        <van-field
          label="转账附言"
          v-model="form.remark"
          type="textarea"
          placeholder="请输入转账附言"
          input-align="right"
          rows="3"
          label-width="auto"
          required
          :rules="[{ required: true , message:'请输入转账附言' }]"
        />
      </div>

      <div class="main_box" style="margin-top: 10px;">
        <van-field label="说明情况" v-model="form.explainSituation" type="textarea" placeholder="请输入说明情况" input-align="right" rows="3" label-width="auto"/>
      </div>

      <p class="main_title" v-if="capitalExpenditureOpen">关联项目</p>
      <div class="main_box" v-if="capitalExpenditureOpen" style="margin-bottom: 10px;margin-top: 10px;position:relative;">
        <van-field
          readonly
          clickable
          label="项目名称"
          placeholder="请选择"
          v-model="projectForm.projectName"
          @click="showproject = true"
          input-align="right"
          right-icon="arrow-down"
          required
          :rules="[{ required: true , message:'请选择项目名称' }]"
        />
        <van-popup v-model="showproject" position="bottom">
          <van-picker
            show-toolbar
            :columns="projectListShow"
            @confirm="onConfirmProject"
            @cancel="showproject = false"
          />
        </van-popup>
        <van-field required :rules="[{ required: true , message:'请输入承建单位' }]" v-model="projectForm.projectContractor" label="承建单位" placeholder="请输入承建单位" input-align="right" label-width="auto"/>
        <van-field required :rules="[{ required: true , message:'请输入合同价款' }]" v-model="projectForm.projectAmount" label="合同价款（元）" placeholder="请输入合同价款（元）" input-align="right" label-width="auto"/>
        <van-field
          readonly
          clickable
          label="工程款类型"
          placeholder="请选择"
          v-model="projectFundType"
          @click="showFundType = true"
          input-align="right"
          right-icon="arrow-down"
          required
          :rules="[{ required: true , message:'请选择工程款类型' }]"
        />
        <van-popup v-model="showFundType" position="bottom">
          <van-picker
            show-toolbar
            :columns="projectFundTypeOptions"
            @confirm="onConfirmFundType"
            @cancel="showFundType = false"
          />
        </van-popup>
        <van-field required :rules="[{ required: true , message:'请输入工程发票号' }]" v-model="projectForm.projectBillNum" label="工程发票号" placeholder="请输入工程发票号" input-align="right" label-width="auto"/>
      </div>

      <p class="main_title">付款方信息</p>
      <div class="main_box">
        <!--      <van-field label="付款方" v-model="form.payer" placeholder="请输入付款方" input-align="right" label-width="auto"/>-->
        <van-field
          readonly
          clickable
          label="付款方"
          placeholder="请选择付款方"
          v-model="form.payer"
          @click="showpayer = true"
          input-align="right"
          right-icon="arrow-down"
          label-width="auto"
          required
          :rules="[{ required: true , message:'请选择付款方' }]"
        />
        <van-popup v-model="showpayer" position="bottom">
          <van-picker
            show-toolbar
            :columns="payerOptions"
            @confirm="onConfirmPayer($event)"
            @cancel="showpayer = false"
          />
        </van-popup>
        <van-field :rules="[{ required: true , message:'请输入付款方账户' }]" required label="付款方账户" v-model="form.payerAccount" placeholder="请输入账户" input-align="right" label-width="auto"/>
      </div>

      <p class="main_title">收款方信息<van-button icon="plus" @click="addChargeItme(chargeItme.length)" size="mini" type="info" native-type="button" class="addFamily"/></p>
      <div class="main_box" style="margin-bottom: 15px;">
        <van-cell title="收款账户类型">
          <template #right-icon>
            <van-radio-group direction="horizontal" v-model="form.accountType" @change="accountTypeChange">
              <van-radio name="1">公户</van-radio>
              <van-radio name="2">私户</van-radio>
            </van-radio-group>
          </template>
        </van-cell>
      </div>
      <div :style="{position:'relative',padding: index == 0 ? '':'10px 0 0 0'}" v-for="(item, index) in chargeItme" :key="index">
        <van-button icon="minus" size="mini" type="danger" class="deleteFamily" native-type="button" v-if="index!=0" @click="deleteChargeItme(index)" />
        <div class="main_box" style="margin-bottom: 10px;position:relative;">
          <van-field
            readonly
            clickable
            label="收款方"
            placeholder="请选择"
            v-model="item.payee"
            @click="item.showPayee = true"
            input-align="right"
            right-icon="arrow-down"
            required
            :rules="[{ required: true , message:'请选择收款方' }]"
          />
          <van-popup v-model="item.showPayee" position="bottom">
            <van-picker
              show-toolbar
              :columns="payeeList"
              @confirm="onConfirmPayee($event,index)"
              @cancel="item.showPayee = false"
            />
          </van-popup>
          <van-field required :rules="[{ required: true , message:'收款账户不能为空' }]" v-model="item.payeeAccount" label="收款账户" placeholder="请选择收款方" input-align="right" label-width="auto"/>
          <van-field required :rules="[{ required: true , message:'开户银行不能为空' }]" v-model="item.bankDeposit" label="开户银行" placeholder="请选择收款方" input-align="right" label-width="auto"/>
          <van-field required :rules="[{ required: true , message:'请输入金额' }]" v-model="item.incomeAmount" type="number"  label="收入金额" placeholder="请输入金额" input-align="right" label-width="auto" @change="moneyChange"/>
          <van-field
            readonly
            clickable
            label="所属银行"
            placeholder="请选择收款方"
            v-model="item.bankTypeText"
            @click="item.showbankType = true"
            input-align="right"
            required
            :rules="[{ required: true , message:'所属银行不能为空 ' }]"
          />
        </div>
      </div>
      <p class="main_title">上传附件</p>
      <div class="main_box" style="padding: 5px 0 0 8px;">
        <van-uploader v-model="fileList" :after-read="beforeRead" @delete="deleteFile"></van-uploader>
      </div>
      <div style="padding: 16px 0;">
        <van-row>
          <van-col span="12" align="center">
            <!--            @click="goUpdate"-->
            <van-button type="info" native-type="submit" @click="buttonType='update'" class="submitButton">保<i style="margin-right: 1em;"></i>存</van-button>
          </van-col>
          <van-col span="12" align="center">
            <!--            @click="goAdd"-->
            <van-button type="info" native-type="submit" @click="buttonType='add'" class="submitButton">保存并提交</van-button>
          </van-col>
        </van-row>
        <div class="clear"></div>
      </div>
    </van-form>
  </div>
</template>

<script>
  import { addTransfer , listPayee , updateTransfer , getProjectto , listProject , addProjectto , customSubmit , getAccount ,getQmyeFlow} from "@/api/onlineHome/bankAgriculture/paymentApproval";
  import {
    attachmentList,
    commonAttach,
    listTaccount,
    listVaccount
  } from "../../../../api/onlineHome/bankAgriculture/paymentApproval";
  import request from '@/utils/request'
  import Dialog from "vant/lib/dialog";
  export default {
    name: "approvalAdd5",
    data() {
      return {
        showcapital:false,
        showpayee:false,
        showlasj:false,
        showbankType:false,
        showproject:false,
        showFundType:false,
        showpayer:false,

        buttonType:'a',

        minDate: new Date(2000, 1, 1),
        maxDate: new Date(2050, 12, 31),
        currentDate: new Date(),
        form:{},
        fileList:[],
        capitalExpenditureType:'',
        payee:'',
        bankType:'',

        wfydlxDictionaries:[],
        jglxDictionaries:[],
        sysDictionaries:[],
        capitalExpenditureTypeOptions:[],
        bankTypeDictionaries:[],
        projectList:[],
        projectFundTypeOptions:[],
        projectFundTypeDictionaries:[],
        projectListShow:[],
        payerOptions:[],

        chargeItme:[],
        chargeItmeShow:[],

        payeeList:[],
        // 查询参数
        queryParams: {
          transferType:"",
          orderByColumn: "id",
          isAsc: "desc",
        },
        capitalExpenditureOpen:false,
        projectForm:{
          projectId:null,
          projectName:null,
          projectContractor:null,
          projectAmount:null,
          projectBillNum:null,
          projectFundType:'1',
          outId:null,
          ynType:'1'
        },
        projectFundType:'',
        uploadFiles:[],
      };
    },
    created() {
      this.reset();
      let queryParams={
        pageNum: 1,
        pageSize: 100,
      }
      listProject(queryParams).then(response => {
        this.projectList = response.rows;
        for (let i = 0; i < response.rows.length; i++) {
          this.projectListShow.push({text: response.rows[i].projectName, value: response.rows[i].id});
        }
      });
      this.getDicts("project_fund_type").then((response) => {
        for (let i = 0; i < response.data.length; i++) {
          this.projectFundTypeOptions.push({text: response.data[i].dictLabel, value: response.data[i].dictValue});
        }
        this.projectFundTypeDictionaries = response.data;
      });
      let params1={
        townAccountType:'2'
      }
      listTaccount(params1).then((response) => {
        console.log(response)
        response.rows.map((res,index) => {
          if(res.townAccountType=='2'){
            res['payerFrom'] = '2'
            this.payerOptions.push(res);
            console.log(res)
            this.payerOptions[index].text = res.payee;
            this.payerOptions[index].value = res.id;
          }
        })
      });
      this.getDictionaries();
    },
    methods: {
      // 表单重置
      reset() {
        this.form = {
          id: null,
          upId: null,
          downId: null,
          orderId: null,
          cashierId: null,
          transferType: '5',
          accountType: '2',
          explainSituation: null,
          succeedAmount: null,
          payer: null,
          payerAccount: null,
          operatorCode: null,
          enterpriseCode: null,
          expenditureAmount: null,
          capitalExpenditureType: '1',
          remark: null,
          transferStatus: "0",
          auditStatus: "0",
          paymentState: "1",
          bankPriority: "0",
          clientPriority: "0"
        };
        this.processList = {}
        this.projectForm={
          projectId:null,
          projectName:null,
          projectContractor:null,
          projectAmount:null,
          projectBillNum:null,
          projectFundType:'1',
          outId:null,
          ynType:'1'
        }
      },
      getChange(){
        console.log(this.buttonType)
        if(this.buttonType == 'update'){
          console.log('update')
          this.goUpdate();
        }else if(this.buttonType == 'add'){
          console.log('add')
          this.goAdd();
        }
      },
      getDictionaries(){
        this.getDicts("capital_expenditure_type").then((res) => {
          for (var i = 0; i < res.data.length; i++) {
            this.capitalExpenditureTypeOptions.push({text: res.data[i].dictLabel, value: res.data[i].dictValue});
          }
        });
        this.getDicts("bank_type").then(res => {
          for (var i = 0; i < res.data.length; i++) {
            this.bankTypeDictionaries.push({text: res.data[i].dictLabel, value: res.data[i].dictValue});
          }
        });

      },
      getError(e){
        console.log(e)
        this.$notify({ type: 'danger', message: e.errors[0].message });
      },
      addChargeItme(index){
        if(this.chargeItme.length>0&&this.chargeItme[this.chargeItme.length-1].payee == ''){
          this.$notify({ type: 'danger', message: '请勿添加多个空列表信息' });
          return;
        }else if(this.chargeItme.length>0&&this.chargeItme[index-1].incomeAmount == ''){
          this.$notify({ type: 'danger', message: '请输入收入金额！' });
          return;
        }else if(this.chargeItme.length>0&&this.chargeItme[index-1].payeeAccount == ''){
          this.$notify({ type: 'danger', message: '请输入收款账户！' });
          return;
        }else if(this.chargeItme.length>0&&this.chargeItme[index-1].bankDeposit == ''){
          this.$notify({ type: 'danger', message: '请输入开户银行！' });
          return;
        }else if(this.chargeItme.length>0&&this.chargeItme[index-1].bankType == ''){
          this.$notify({ type: 'danger', message: '请选择所属银行！' });
          return;
        }
        this.getDicts("bank_type").then(res => {
          this.chargeItme.splice(index + 1, 0, {
            payeeId: "", //收款方ID
            payee: "", //收款方
            payeeAccount: "", //收款账户
            bankDeposit: "", //开户银行
            incomeAmount: "", //收入金额
            bankType: "", //所属银行
            bankTypeText:"", //所属银行
            showPayee:false,
            showbankType:false
          });
        });
        this.getPayeeList();
      },
      getPayeeList() {
        //普通转账
        this.queryParams.accountType = this.form.accountType
        this.queryParams.status = "0"
        if(this.form.cashierId==null||this.form.cashierId==""){
          this.$notify({ type: 'danger', message: '请先选择付款方！' });
          return;
        }else {
          this.queryParams.taccountId = parseInt(this.form.cashierId)
          listVaccount(this.queryParams).then((response) => {
            this.payeeList = response.rows;
            response.rows.map((res,index) => {
              this.payeeList[index].text = res.payee;
              this.payeeList[index].value = res.id;
            })
          });
        }
      },
      payeeDictLabel(datas, value) {
        let actions = [];
        Object.keys(datas).some((key) => {
          if (datas[key].payeeId == ('' + value)) {
            actions.push(datas[key].payee);
            return true;
          }
        })
        return actions.join('');
      },
      onConfirmCapital(data){
        if (data.value != 2){
          this.capitalExpenditureOpen = false;
          this.projectForm = [];
        }else{
          this.capitalExpenditureOpen = true;
        }
        this.capitalExpenditureType = data.text;
        this.form.capitalExpenditureType = data.value;
        this.showcapital = false;
      },
      onConfirmFundType(data){
        console.log(data)
        this.projectForm.projectFundType = data.value;
        this.projectFundType = data.text;
        this.showFundType = false;
      },
      onConfirmProject(data){
        this.projectList.map(res => {
          if(res.projectName==data.text){
            this.projectForm.projectId = res.id
            this.projectForm.projectName = res.projectName
            this.projectForm.projectContractor = res.projectContractor
            this.projectForm.projectAmount = res.projectAmount
          }
        })
        this.showproject = false;
      },
      onConfirmPayee(data,index){
        for (let i = 0 ; i < this.chargeItme.length ; i++){
          this.chargeItme[i].showPayee = false;
        }
        this.chargeItme[index].payee = data.text;
        this.chargeItme[index].payeeId = data.value;
        this.chargeItme[index].showpayee = false;
        this.payeeSelectChange(data.value , index)
        this.onConfirmBankType(data,index);
      },
      onConfirmBankType(data,index){
        console.log(this.bankTypeDictionaries)
        this.bankTypeDictionaries.map(res => {
          if(res.value==data.bankType){
            this.chargeItme[index].bankTypeText = res.text;
            this.chargeItme[index].bankType = res.value;
          }
        })
      },
      onConfirmPayer(data){
        console.log(data)
        this.form.payer = data.text;
        this.form.cashierId = data.value;
        this.form.payerAccount = data.payeeAccount;
        this.showpayer = false;
        // this.selectChange(data.value)
        this.accountTypeChange();
      },
      onConfirmLasj(data){
        this.form.applyDate = this.getNowFormatDate(data).substr(0,10);
        this.showlasj = false;
      },
      accountTypeChange(e){
        this.payeeList = [];
        this.chargeItme = [];
        this.queryParams.accountType = this.form.accountType
        if(this.form.cashierId==null||this.form.cashierId==""){
          this.$notify({ type: 'danger', message: '请先选择付款方！' });
          return;
        }else {
          this.queryParams.taccountId = parseInt(this.form.cashierId)
          console.log(this.queryParams)
          listVaccount(this.queryParams).then((response) => {
            this.payeeList = response.rows;
            response.rows.map((res,index) => {
              this.payeeList[index].text = res.payee;
              this.payeeList[index].value = res.id;
            })
          });
        }
      },
      // 钱计算
      moneyChange(input) {
        console.log(input)
        let obj = {};
        obj = this.chargeItme.find((account) => {
          //model就是上面的数据源
          return parseFloat(account.incomeAmount).toFixed(2) === input; //筛选出匹配数据
        });
        let total = 0;
        this.chargeItme.forEach((money) => {
          total = (parseFloat(total) + parseFloat(money.incomeAmount)).toFixed(2)
        });
        this.$set(this.form, "expenditureAmount", total);
      },
      goAdd(){
        if(this.chargeItme.length<1){
          this.$notify({ type: 'danger', message: '请添加收款方信息' });
          return;
        }
        if(this.form.remark != null && this.form.remark.indexOf("|")!=-1){
          this.$notify({ type: 'danger', message: '转账附言禁止包含！' });
          return;
        }
        if(this.form.capitalExpenditureType==2){
          if(this.projectForm.projectName==""||this.projectForm.projectName==null){
            this.$notify({ type: 'danger', message: '请选择项目名称！' });
            return;
          }
          if(this.projectForm.projectBillNum==""||this.projectForm.projectBillNum==null){
            this.$notify({ type: 'danger', message: '请输入工程发票号！' });
            return;
          }
        }
        if((this.uploadFiles==null||this.uploadFiles.length==0)&&(this.fileList==null||this.fileList.length==0)){
          Dialog.confirm({
            title: '提示',
            message: '此申请单中未上传任何附件，是否确认提交？',
          })
            .then(() => {
              this.$set(this.form, "payeeList", this.chargeItme);
              this.$set(this.form, "bankTypeList", this.chargeItme);
              this.$set(this.form, "accountTypeList", this.chargeItme);
              this.$set(this.form, "transferStatusList", this.chargeItme);
              addTransfer(this.form).then(response => {
                this.projectForm.outId = response.data.id
                this.$set(this.projectForm, "ynType", '1');
                if(this.uploadFiles!=null&&this.uploadFiles.length>0){
                  this.uploadFiles.map(rr => {
                    const params = new FormData();
                    params.append("tableId", response.data.id);
                    params.append("tableName", "t_yinnong_transfer");
                    params.append("bizPath", "upload");
                    params.append("fileType", "0");
                    params.append("file", rr);
                    commonAttach(params).then((r) => {
                    })
                  })
                  if(this.form.capitalExpenditureType==2){
                    addProjectto(this.projectForm).then(res => {
                      customSubmit(response.data.id).then(res => {
                        this.$toast.success('提交成功');
                        setTimeout(function(){
                          history.go(-1)
                        },2000)
                      })
                    })
                  }else{
                    customSubmit(response.data.id).then(res => {
                      this.$toast.success('提交成功');
                      setTimeout(function(){
                        history.go(-1)
                      },2000)
                    })
                  }
                }else{
                  if(this.form.capitalExpenditureType==2){
                    addProjectto(this.projectForm).then(res => {
                      customSubmit(response.data.id).then(res => {
                        this.$toast.success('提交成功');
                        setTimeout(function(){
                          history.go(-1)
                        },2000)
                      })
                    })
                  }else{
                    customSubmit(response.data.id).then(res => {
                      this.$toast.success('提交成功');
                      setTimeout(function(){
                        history.go(-1)
                      },2000)
                    })
                  }
                }
              });
            })
            .catch(() => {
              return false;
            });
        }else{
          this.$set(this.form, "payeeList", this.chargeItme);
          this.$set(this.form, "bankTypeList", this.chargeItme);
          this.$set(this.form, "accountTypeList", this.chargeItme);
          this.$set(this.form, "transferStatusList", this.chargeItme);
          addTransfer(this.form).then(response => {
            this.projectForm.outId = response.data.id
            this.$set(this.projectForm, "ynType", '1');
            if(this.uploadFiles!=null&&this.uploadFiles.length>0){
              this.uploadFiles.map(rr => {
                const params = new FormData();
                params.append("tableId", response.data.id);
                params.append("tableName", "t_yinnong_transfer");
                params.append("bizPath", "upload");
                params.append("fileType", "0");
                params.append("file", rr);
                commonAttach(params).then((r) => {
                })
              })
              if(this.form.capitalExpenditureType==2){
                addProjectto(this.projectForm).then(res => {
                  customSubmit(response.data.id).then(res => {
                    this.$toast.success('提交成功');
                    setTimeout(function(){
                      history.go(-1)
                    },2000)
                  })
                })
              }else{
                customSubmit(response.data.id).then(res => {
                  this.$toast.success('提交成功');
                  setTimeout(function(){
                    history.go(-1)
                  },2000)
                })
              }
            }else{
              if(this.form.capitalExpenditureType==2){
                addProjectto(this.projectForm).then(res => {
                  customSubmit(response.data.id).then(res => {
                    this.$toast.success('提交成功');
                    setTimeout(function(){
                      history.go(-1)
                    },2000)
                  })
                })
              }else{
                customSubmit(response.data.id).then(res => {
                  this.$toast.success('提交成功');
                  setTimeout(function(){
                    history.go(-1)
                  },2000)
                })
              }
            }
          });
        }


      },
      goUpdate(){
        if(this.chargeItme.length<1){
          this.$notify({ type: 'danger', message: '请添加收款方信息' });
          return;
        }
        if(this.form.remark != null && this.form.remark.indexOf("|")!=-1){
          this.$notify({ type: 'danger', message: '转账附言禁止包含！' });
          return;
        }
        if(this.form.capitalExpenditureType==2){
          if(this.projectForm.projectName==""||this.projectForm.projectName==null){
            this.$notify({ type: 'danger', message: '请选择项目名称！' });
            return;
          }
          if(this.projectForm.projectBillNum==""||this.projectForm.projectBillNum==null){
            this.$notify({ type: 'danger', message: '请输入工程发票号！' });
            return;
          }
        }
        this.$set(this.form, "payeeList", this.chargeItme);
        this.$set(this.form, "bankTypeList", this.chargeItme);
        this.$set(this.form, "accountTypeList", this.chargeItme);
        this.$set(this.form, "transferStatusList", this.chargeItme);
        console.log(this.form)
        addTransfer(this.form).then((response) => {
          this.projectForm.outId = response.data.id
          this.$set(this.projectForm, "ynType", '1');
          if(this.uploadFiles!=null&&this.uploadFiles.length>0){
            console.log(this.uploadFiles)
            this.uploadFiles.map(rr => {
              const params = new FormData();
              params.append("tableId", response.data.id);
              params.append("tableName", "t_yinnong_transfer");
              params.append("bizPath", "upload");
              params.append("fileType", "0");
              params.append("file", rr);
              commonAttach(params).then((r) => {
              })
            })
            if(this.form.capitalExpenditureType==2){
              addProjectto(this.projectForm).then(res => {
                this.$toast.success('保存成功');
                setTimeout(function(){
                  history.go(-1)
                },2000)
              })
            }else{
              this.$toast.success('保存成功');
              setTimeout(function(){
                history.go(-1)
              },2000)
            }
          }else{
            if(this.form.capitalExpenditureType==2){
              addProjectto(this.projectForm).then(res => {
                this.$toast.success('保存成功');
                setTimeout(function(){
                  history.go(-1)
                },2000)
              })
            }else{
              this.$toast.success('保存成功');
              setTimeout(function(){
                history.go(-1)
              },2000)
            }
          }

        });
      },
      payeeSelectChange(select, i) {
        let obj = {};
        let fuzhitype = 0;
        obj = this.payeeList.find((account) => {
          //model就是上面的数据源
          return account.id === select ; //筛选出匹配数据
        });
        if(this.chargeItme != [] && this.chargeItme.length>1){
          this.chargeItme.some((value, index) => {
            if(value.payeeAccount != undefined &&value.payeeAccount != '' && obj.payeeAccount == value.payeeAccount&&index!=i){
              fuzhitype = 2;
              return true;
            }
            if(value.accountType != undefined &&value.accountType != '' && obj.accountType != value.accountType&&index!=i){
              fuzhitype = 1;
              return true;
            }
          });
        }
        if(fuzhitype == 0){
          this.$set(this.chargeItme[i], "payee",obj.payee)
          this.$set(this.chargeItme[i], "bankType", obj.bankType)
          this.$set(this.chargeItme[i], "payeeId", obj.id);
          this.$set(this.chargeItme[i], "payeeAccount", obj.payeeAccount);
          this.$set(this.chargeItme[i], "bankDeposit", obj.bankDeposit);
          this.$set(this.chargeItme[i], "accountType", obj.accountType);
        }else if(fuzhitype == 1){
          this.$set(this.chargeItme[i], "payee",'')
          this.$set(this.chargeItme[i], "bankType",'')
          this.$set(this.chargeItme[i], "payeeId", '');
          this.$set(this.chargeItme[i], "payeeAccount", '');
          this.$set(this.chargeItme[i], "bankDeposit", '');
          this.$set(this.chargeItme[i], "accountType", '');
          this.$notify({ type: 'danger', message: '请选择账户类型相同的收款方！' });
        }else if(fuzhitype == 2){
          this.$set(this.chargeItme[i], "payee",'')
          this.$set(this.chargeItme[i], "bankType",'')
          this.$set(this.chargeItme[i], "payeeId", '');
          this.$set(this.chargeItme[i], "payeeAccount", '');
          this.$set(this.chargeItme[i], "bankDeposit", '');
          this.$set(this.chargeItme[i], "accountType", '');
          this.$notify({ type: 'danger', message: '收款方已存在！' });
        }
      },
      selectChange(select) {
        let obj = {};
        obj = this.payerOptions.find((account) => {
          //model就是上面的数据源
          return account.id === select; //筛选出匹配数据
        });
        if(obj.payerFrom==1&&obj.operatorCode != null && obj.operatorCode != "" &&
          obj.enterpriseCode != null && obj.enterpriseCode != "" &&
          obj.accountPassword != null && obj.accountPassword != ""){
          this.$set(this.form, "bookId", obj.bookId);
          this.$set(this.form, "deptId", obj.deptId);
          this.$set(this.form, "cashierId", obj.id);
          this.$set(this.form, "payer", obj.accountName);
          this.$set(this.form, "payerAccount", obj.bankAccountNumber);
          this.$set(this.form, "operatorCode", obj.operatorCode);
          this.$set(this.form, "enterpriseCode", obj.enterpriseCode);
          this.$set(this.form, "payerFrom", '1');
        }else{
          if(obj.payerFrom==1){
            this.diglogStatus = false;
            this.$notify({ type: 'danger', message: "请完善付款方“操作员代码”、“企业编码”、“支付口令”等信息！" });
            this.$set(this.form,"payer","")
            this.$set(this.form,"payerAccount","")
          }else{
            this.$set(this.form, "payerFrom", obj.parerFrom);
            if(obj.operatorCode!=null&&obj.operatorCode!=''){
              this.$set(this.form, "operatorCode", obj.operatorCode);
            }else{
              this.$set(this.form, "operatorCode", '');
            }
            if(obj.enterpriseCode!=null&&obj.enterpriseCode!=''){
              this.$set(this.form, "enterpriseCode", obj.enterpriseCode);
            }else{
              this.$set(this.form, "enterpriseCode", '');
            }
            if(obj.accountPassword!=null&&obj.accountPassword!=''){
              this.$set(this.form, "accountPassword", obj.accountPassword);
            }else{
              this.$set(this.form, "accountPassword", '');
            }
            this.$set(this.form, "bookId",'');
            this.$set(this.form, "deptId", '');
            this.$set(this.form, "cashierId", obj.id);
            this.$set(this.form, "payer", obj.accountName);
            if(obj.payerFrom==6){
              getQmyeFlow(obj.bankAccountNumber).then((response) => {
                this.$set(this.form, "payerAccount", response.data);
              });
            }else {
              this.$set(this.form, "payerAccount", obj.bankAccountNumber);
            }
          }
        }
      },
      beforeRead(file) {
        this.uploadFiles.push(file.file);
      },
      deleteFile(file){
        this.uploadFiles.map((response,index) => {
          if(file.file == response){
            this.uploadFiles.splice(index,1)
          }
        })
      },
      getFileList(){
        let oData= {
          tableId: this.$route.query.id,
          tableName: "t_yinnong_transfer",
          bizPath: "upload",
          fileType: "0",
        }
        attachmentList(oData).then(res => {
          console.log(res)
          console.log(location.protocol+"//"+location.host+request.defaults.baseURL)
          res.rows.map(r => {
            let baseUrl = location.protocol+"//"+location.host+request.defaults.baseURL
            this.fileList.push({"url":baseUrl + r.fileUrl,"file":new File([],r.fileName,{})})
            console.log(r)
          })
        })
      },
      goBack(){
        window.history.go(-1)
      },
      //删除家庭成员
      deleteChargeItme(index){
        this.chargeItme.splice(index,1)
      },
    },
  }
</script>

<style scoped lang="scss">
  .app-container {
    padding: 2% 0;
  }
  .main_title{
    font-size: 0.4rem;
    color: #1D6FE9;
    margin: 0.2rem 6%;
    position: relative;
  }
  .main_box{
    width: 96%;
    margin: 0 auto;
    border-radius: 6px;
    box-shadow: 0px 3px 6px 0px rgba(0,0,0,0.16);
    overflow: hidden;
    background-color: #FFF;
  }
  .submitButton{
    width: 80%;
    margin: 0 auto;
    background-color: #1D6FE9;
  }

  .addFamily{
    position: absolute;
    top: -2px;
    right: 0;
    border-radius: 50%;
  }
  .deleteFamily{
    position: absolute;
    top: 0rem;
    right: 6%;
    z-index: 9;
    border-radius: 50%;
  }
</style>
